
#include "ts4740.h"

void ack_startup(void) {
	outint(get_us());
	outstr(" \n");
}

void shutdown(void) {
	POKE16(FIFO_STAT, 0x1000);
}

unsigned int get_us(void) {
	unsigned int high, low;
	high = PEEK16(TIMER1);
	low = PEEK16(TIMER0);
	if (high == PEEK16(TIMER1)) return (high << 16) + low;
	else return get_us();
}

void usleep(unsigned int usec) {
	unsigned int t1;
	t1 = get_us();
	while (get_us() - t1 < usec) {};
}

void outstr(char *s) {
	unsigned int i = 0, j = 0;
	while (s[i] != 0) {
		while (j <= 1) {
			j = PEEK16(FIFO_STAT) & 0x7ff;
			if (j & 0x400) j = 0; // full
			else j = 0x400 - j;
		}
		if (s[i] == 0xa) { // add line feed to newline
			POKE16(FIFO_DAT, 0xd);
			j--;
		}
		POKE16(FIFO_DAT, s[i]);
		j--;
		i++;
	}
}

void outint(unsigned int x) {
	if (x & 0x80000000) {
		outstr("-");
		outint(0 - x);
		return;
	}
	if (x > 9) outint(x/10);

	while(PEEK16(FIFO_STAT) & 0x800) {}; // fifo full
	POKE16(FIFO_DAT, '0' + x%10);
}

void outhex(unsigned int x) {
	unsigned char d;

	if (x & 0xfffffff0) outhex(x >> 4);
	while(PEEK16(FIFO_STAT) & 0x800) {}; // fifo full
	d = x & 0xf;
	if (d > 9) POKE16(FIFO_DAT, 'a' - 10 + d);
	else POKE16(FIFO_DAT, '0' + d);
}
